jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]

SetScene{
  enviroment = "mountains",
	glowpasses = ifhifi(0,0),
	glowspread = ifhifi(0,0),
	radialblur_strength = 0.5,
	watertype = 0,
	water = jumping,
	watertint = {r=250,g=250,b=250,a=30},
	watertexture = "WaterCubesBlue_BlackTop_WhiteLowerTier.png",
	towropes = false,
	airdebris_count = 500,
	airdebris_density = 150,
	usedefaultrails=true,
	useblackgrid=false,
	fullfuture = true,
	twistmode={curvescaler=1, steepscaler=.1}
}
SetBlockFlashes{
	--texture="hit.png"
}

SetPuzzleGraphics{
	usesublayerclone = false,
	puzzlematerial={
		texture = "grid.png",
		shader = fif(ispuzzle, "VertexColorUnlitTintedAlpha", "DiffuseVertexColored")
	},
	puzzlematchmaterial={
		texture = "matching.png",
		shader = "Particles/Additive"
	},
	puzzleflyupmaterial={
		texture = "matching.png",
		shader = "Particles/Additive"
	}
}

if not jumping then
	SetBlocks{
		colorblocks={
    		shadowcaster = true,
			shadowreceiver = false,
			reflect = true,
			mesh = "4star_dragonball.obj",
			shader = "Diffuse",
			shadersettings = fif(hifi, {_Brightness=1.0}, {_Brightness=1}),
      		shadercolors={
			_Color={colorsource="node", scaletype="intensity", minscaler=1, maxscaler=1}
		},
			textures = {_MainTex="energy_ball.png", _MatCap="matcapchrome.jpg"}, --matcapchrome.jpg"},
			--texture = "matcapchrome.jpg", --"energy_ball.png",
		    height = 1.5,
		    float_on_water = false,
		    scale = {2,2,2}
		},
		greyblocks={
    		shadowcaster = true,
			shadowreceiver = true,
			mesh = "singlespike.obj",
			shader = "Diffuse",
			texture = "grey1.png",
			float_on_water = false,
			height = 1.5,
		},
		powerups={--override the following objects in case the mod uses them
			powerpellet={
				mesh = "4star_dragonball.obj",
				shader = fif(hifi,"MatCap/Vertex/Textured Lit Double Mult", "MatCap/Vertex/PlainBright"),
				shadersettings = fif(hifi, {_Brightness=1.0}, {_Brightness=1}),
				textures = {_MainTex="4star_dragonball.png", _MatCap="4star_dragonball.png"}, --matcapchrome.jpg"},
				scale = {2.7,2.7,2.7},
				reflect = true,
				shadercolors = {_Color="highway"} -- power block
			}
		}
	}
	
	SetPlayer{
		cameramode = "third",
		camfirst={
			pos={0,7.84,-1.8},
			rot={20,0,0}},
		camthird={
			pos={0,7,-1.5},
			rot={30,0,0},
			strafefactor = 0.75,
			pos2={0,8,-5},
			rot2={30,0,0},
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-0.65,
			puzzleoffset2=-1.5},
      
			
		vehicle={
			min_hover_height= 0.23,
			max_hover_height = 0.8,
			use_water_rooster = false,
            smooth_tilting = true,
            smooth_tilting_speed = 10,
            smooth_tilting_max_offset = -20,
			pos={x=0,y=-2.0,z=0},
      		shadowcaster = true,
		shadowreceiver = true,
			mesh="goku_fly.obj", -- mesh
			shader = "Diffuse",
			layer = 14,
			renderqueue = 2000,
			shadercolors={
				_Color = {colorsource="texture", scaletype="intensity", minscaler=1, maxscaler=1}},
			texture="goku_skin.png", -- skin
			scale = {x=1.2,y=1.2,z=1.2},
		}
	}
end

if jumping then
	SetBlocks{
		colorblocks={
			mesh = "4star_dragonball.obj",
			shader = "Diffuse",
      		shadercolors={
			_Color={colorsource="node", scaletype="intensity", minscaler=1, maxscaler=1}
		},
			texture = "4star_dragonball.png",
		    height = 0,
		    float_on_water = false,
		    scale = {2,2,2}
		},
		greyblocks={
			mesh = "singlespike.obj",
			shader = "Diffuse",
			texture = "grey1.png",
      float_on_water = false,
      height = 0,
      scale = {3,3,3}
		}
	}
	
	SetPlayer{
		cameramode = "third",
		camfirst={
			pos={0,3,-1},
			rot={30,0,0}},
		camthird={
			pos={0,2.5,-3},
			rot={10,0,0},
			strafefactor = 0.75,
			pos2={0,5,-4},
			rot2={28,0,0},
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-0.85,
			puzzleoffset2=-1.75},
			
		vehicle={
			min_hover_height= 0.23,
			max_hover_height = 0.8,
			use_water_rooster = false,
            smooth_tilting = true,
            smooth_tilting_speed = 10,
            smooth_tilting_max_offset = -20,
			pos={x=0,y=-1.0,z=0},
			mesh="goku_fly.obj", -- mesh
			shader="VertexColorUnlitTinted",
			layer = 14,
			renderqueue = 2000,
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
			texture="goku_skin.png", -- skin
			scale = {x=1.2,y=1.2,z=1.2},
		}
	}
end



SetSkybox{ --this shows how to set up a skybox. There's also a dynamic sky system that's used by the audiosprint skin. It could be used here too.
	custom={
		_FrontTex = "clouds_sides.png",
		_BackTex = "clouds_sides.png",
		_RightTex = "clouds_sides.png",
		_LeftTex = "clouds_sides.png",
		_UpTex = "clouds_upper.png",
		_DownTex = "clouds_lower.png"
	}
}

CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="BuildingCloneMe",
	gameobject={
		mesh="nimbus.obj",
		shader="Diffuse",
		texture="nimbus.png",
    pos= {x=0,y=0,z=0},
		scale = {x=20,y=20,z=20}
	}
}

 -- put light back here
if not jumping then
	CreateLight{
	  globalname = "light",
		type= "directional",
		railoffset = -1,
		intensity = 0.8,
		--shadows={type="soft",strength=1},
		transform = {
			position={0,200,0},
	   rotation={0,0,0}
		},
		color={255,255,255}
	}
end

track = GetTrack()--get the track data from the game engine

if buildingNodes == nil then
	buildingNodes = {} --the track is made of nodes, each one with a position and rotation. This table will hold the indices of track nods that should have a skyscraper rendered at them (with some offset)
	offsets = {}
	buildingNodesToo = {}
	offsetsToo = {}
	for i=1,#track do
		if i%36==0 then
			buildingNodes[#buildingNodes+1] = i
			local xOffset = 15 + 65*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			offsets[#offsets+1] = {xOffset,50,0}
		end

		--if (i+5)%40==0 then
		--	buildingNodesToo[#buildingNodesToo+1] = i
		--	local xOffset = 10 + 65*math.random()
		--	if math.random() > 0.5 then xOffset = xOffset * -1 end
		--	offsetsToo[#offsetsToo+1] = {xOffset,150,0}
		--end
	end

	BatchRenderEveryFrame{prefabName="BuildingCloneMe", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
							locations=buildingNodes,
                    		rotateWithTrack=false,
                    		maxShown=30,
                    		maxDistanceShown=2000,
							offsets=offsets,
							collisionLayer = 13,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
							testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
						}
            
                      
end

SetTrackColors{
    {r=255, g=255, b=255},
    {r=255, g=255, b=255},
    {r=255, g=255, b=255},
    {r=255, g=255, b=255},
	{r=255, g=255, b=255}
}

SetBlockColors{ --this is only used for puzzle modes (which you don't have yet) with multiple colors of blocks
    {r=93, g=8, b=132},
	{r=1.0, g=0.27, b=0.2},
    {r=0.047, g=0.5098, b=0.94},
    {r=1.0, g=0.85, b=0.4157},
	{r=0, g=0.29, b=0.08},
    {r=1,g=0,b=0}
}

SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	texture="Invisible_OnBlack.png",
	--texture="Classic_OnBlack",
	shader="VertexColorUnlitTintedAddSmooth",
	size=trackWidth*2,
	percentringed=.10,
	fullfuture = true,
	airtexture="Bits.png",
	airshader="VertexColorUnlitTintedAddSmoothNoDepth",
	airsize=16
}

wakeHeight = 2
if jumping then wakeHeight=2 else wakeHeight = 0 end
SetWake{
	height = wakeHeight,
	fallrate = 0.95,
	shader = "VertexColorUnlitTinted",
	layer = 13,
	bottomcolor = {r=175,g=175,b=175},
	topcolor = "highway"
}

CreateObject{
	name="endportal",
	tracknode="end",
	gameobject={
	    scale = {x=40,y=40,z=40},
		mesh="4star_dragonball.obj",
		renderqueue=1000,
		flatten=false,
		layer=18,
		shader="Diffuse",
		texture="king_kai_planet.png"
	}
}

--RAILS. rails are the bulk of the graphics in audiosurf. Each one is a 2D shape extruded down the length of the track.

if not jumping then
	local laneDividers = skinvars["lanedividers"]
	for i=1,#laneDividers do
		CreateRail{ -- lane line
			positionOffset={
				x=laneDividers[i],
				y=0.1},
			crossSectionShape={
				{x=-.07,y=0},
				{x=.07,y=0}},
			perShapeNodeColorScalers={
				1,
				1},
			colorMode="static",
			color = {r=200,g=200,b=200},
			flatten=false,
			nodeskip = 2,
			wrapnodeshape = false,
			shader="VertexColorUnlitTinted"
		}
	end
end

	local laneDividers = skinvars["lanedividers"]
	if #laneDividers>2 then fivelane = true else fivelane = false end
	if #laneDividers>6 then sevenlane = true else sevenlane = false end

CreateRepeatedMeshRail{
    ahead_renderdist = 1000,
    behind_renderdist = 30,
    spacing = 0, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highway" --"highwayinverted"
    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 10, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    	flatten=false,

	gameobject={
		name="meshrailproto1",
		shadowcaster = false,
		shadowreceiver = false,
		mesh= "snake_track0.obj", --fif(sevenlane, "snake_track1.obj", fif(fivelane, "snake_track0.obj", "snake_track0.obj")), --track_model
		layer=13, --13
		shader="Diffuse",
		colorMode="highway",
		Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1},
		shadercolors={
			_Color={colorsource="node", scaletype="intensity", minscaler=1, maxscaler=1}
		},
		texture="snake_track0_new.png"
	}
}